Index: palm/trunk/SOURCE/vertical_nesting_mod.f90
===================================================================
--- palm/trunk/SOURCE/vertical_nesting_mod.f90	(revision 2693)
+++ palm/trunk/SOURCE/vertical_nesting_mod.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file vertical_nesting_mod.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
@@ -16,4 +16,5 @@
 !
 ! Copyright 1997-2017 Leibniz Universitaet Hannover
+! Copyright 2017-2017 Karlsruhe Institute of Technology
 !------------------------------------------------------------------------------!
 !
@@ -25,4 +26,10 @@
 ! -----------------
 ! $Id$
+! renamed diffusivities to tcm_diffusivities (TG)
+! 
+! 2516 2017-10-04 11:03:04Z suehring
+! Remove tabs
+! 
+! 2514 2017-10-04 09:52:37Z suehring
 ! Remove tabs
 ! 
@@ -186,5 +193,6 @@
         USE surface_mod,                                                        &
             ONLY :  surf_def_h, surf_def_v
-        
+        USE turbulence_closure_mod,                                             &
+            ONLY :  tcm_diffusivities
    
         IMPLICIT NONE
@@ -554,7 +562,7 @@
            !diffusivities required
            IF ( .NOT. humidity ) THEN
-               CALL diffusivities( pt, pt_reference )
+               CALL tcm_diffusivities( pt, pt_reference )
            ELSE
-               CALL diffusivities( vpt, pt_reference )
+               CALL tcm_diffusivities( vpt, pt_reference )
            ENDIF
    
Index: palm/trunk/SOURCE/virtual_flight_mod.f90
===================================================================
--- palm/trunk/SOURCE/virtual_flight_mod.f90	(revision 2693)
+++ palm/trunk/SOURCE/virtual_flight_mod.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file virtual_flights_mod.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
Index: palm/trunk/SOURCE/wind_turbine_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/wind_turbine_model_mod.f90	(revision 2693)
+++ palm/trunk/SOURCE/wind_turbine_model_mod.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file wind_turbine_model_mod.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
Index: palm/trunk/SOURCE/write_3d_binary.f90
===================================================================
--- palm/trunk/SOURCE/write_3d_binary.f90	(revision 2693)
+++ palm/trunk/SOURCE/write_3d_binary.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file write_3d_binary.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! + kh_av, km_av (TG)
+! 
+! 2292 2017-06-20 09:51:42Z schwenkel
 ! Implementation of new microphysic scheme: cloud_scheme = 'morrison' 
 ! includes two more prognostic equations for cloud drop concentration (nc)  
@@ -162,5 +165,5 @@
 !
 !-- Write arrays.
-    binary_version = '4.5'
+    binary_version = '4.6'
 
     WRITE ( 14 )  binary_version
@@ -179,5 +182,11 @@
     WRITE ( 14 )  'iran                ';  WRITE ( 14 )  iran, iran_part
     WRITE ( 14 )  'kh                  ';  WRITE ( 14 )  kh
+    IF ( ALLOCATED( kh_av ) )  THEN
+       WRITE ( 14 )  'kh_av               ';  WRITE ( 14 )  kh_av
+    ENDIF
     WRITE ( 14 )  'km                  ';  WRITE ( 14 )  km
+    IF ( ALLOCATED( km_av ) )  THEN
+       WRITE ( 14 )  'km_av               ';  WRITE ( 14 )  km_av
+    ENDIF
     IF ( ALLOCATED( lpt_av ) )  THEN
        WRITE ( 14 )  'lpt_av              ';  WRITE ( 14 )  lpt_av
Index: palm/trunk/SOURCE/write_var_list.f90
===================================================================
--- palm/trunk/SOURCE/write_var_list.f90	(revision 2693)
+++ palm/trunk/SOURCE/write_var_list.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file write_var_list.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
@@ -25,4 +25,9 @@
 ! -----------------
 ! $Id$
+! + rans_mode, turbulence_closure (TG)
+! Implementation of chemistry module (FK)
+! Removal of chemistry module part. It is not needed and causes bugs (FK)
+! 
+! 2576 2017-10-24 13:49:46Z Giersch
 ! The end of the standard parameter list is again marked with *** end *** like 
 ! it was before revision 2563
@@ -256,5 +261,5 @@
 
 
-    binary_version = '4.4'
+    binary_version = '4.5'
 
     WRITE ( 14 )  binary_version
@@ -545,4 +550,6 @@
     WRITE ( 14 )  'random_heatflux               '
     WRITE ( 14 )  random_heatflux
+    WRITE ( 14 )  'rans_mode                     '
+    WRITE ( 14 )  rans_mode
     WRITE ( 14 )  'rayleigh_damping_factor       '
     WRITE ( 14 )  rayleigh_damping_factor
@@ -671,4 +678,6 @@
     WRITE ( 14 )  'tunnel_wall_depth             '
     WRITE ( 14 )  tunnel_wall_depth
+    WRITE ( 14 )  'turbulence_closure            '
+    WRITE ( 14 )  turbulence_closure
     WRITE ( 14 )  'collision_turbulence          '
     WRITE ( 14 )  collision_turbulence
@@ -762,4 +771,8 @@
     WRITE ( 14 )  '*** end ***                   '
 
+!    
+!-- ADD NEW "CALL <module>_skip_var_list" BELOW THE LAST CALL
+!-- (The order of the calls MUST be the same as in parin, and
+!--  read/skip_var_list)!
 !
 !-- If required, write restart data for wind turbine model.
@@ -775,3 +788,4 @@
 
 
+
  END SUBROUTINE write_var_list
Index: palm/trunk/UTIL/Makefile_utilities
===================================================================
--- palm/trunk/UTIL/Makefile_utilities	(revision 2693)
+++ palm/trunk/UTIL/Makefile_utilities	(revision 2696)
@@ -1,4 +1,4 @@
-#--------------------------------------------------------------------------------#
-# This file is part of PALM.
+#------------------------------------------------------------------------------#
+# This file is part of the PALM model system.
 #
 # PALM is free software: you can redistribute it and/or modify it under the terms
@@ -13,6 +13,6 @@
 # PALM. If not, see <http://www.gnu.org/licenses/>.
 #
-# Copyright 1997-2014  Leibniz Universitaet Hannover
-#--------------------------------------------------------------------------------#
+# Copyright 1997-2017  Leibniz Universitaet Hannover
+#------------------------------------------------------------------------------#
 #
 # Current revisions:
@@ -42,5 +42,5 @@
 # ------------
 # Makefile for generating the utility programs required by mrun and palm
-#--------------------------------------------------------------------------------#
+#------------------------------------------------------------------------------#
 
 PROG1 =  combine_plot_fields.x
Index: palm/trunk/UTIL/analyze_particle_netcdf_data.f90
===================================================================
--- palm/trunk/UTIL/analyze_particle_netcdf_data.f90	(revision 2693)
+++ palm/trunk/UTIL/analyze_particle_netcdf_data.f90	(revision 2696)
@@ -2,9 +2,10 @@
 
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
-!
-! PALM is free software: you can redistribute it and/or modify it under the terms
-! of the GNU General Public License as published by the Free Software Foundation,
-! either version 3 of the License, or (at your option) any later version.
+! This file is part of the PALM model system.
+!
+! PALM is free software: you can redistribute it and/or modify it under the
+! terms of the GNU General Public License as published by the Free Software
+! Foundation, either version 3 of the License, or (at your option) any later
+! version.
 !
 ! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
@@ -15,6 +16,6 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 1997-2014  Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------!
+! Copyright 1997-2017  Leibniz Universitaet Hannover
+!------------------------------------------------------------------------------!
 !
 ! Current revisions:
Index: palm/trunk/UTIL/check_pegrid.f90
===================================================================
--- palm/trunk/UTIL/check_pegrid.f90	(revision 2693)
+++ palm/trunk/UTIL/check_pegrid.f90	(revision 2696)
@@ -1,10 +1,11 @@
  PROGRAM check_pegrid
 
-!--------------------------------------------------------------------------------!
-! This file is part of PALM.
+!------------------------------------------------------------------------------!
+! This file is part of the PALM model system.
 !
-! PALM is free software: you can redistribute it and/or modify it under the terms
-! of the GNU General Public License as published by the Free Software Foundation,
-! either version 3 of the License, or (at your option) any later version.
+! PALM is free software: you can redistribute it and/or modify it under the
+! terms of the GNU General Public License as published by the Free Software
+! Foundation, either version 3 of the License, or (at your option) any later
+! version.
 !
 ! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
@@ -15,6 +16,6 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 1997-2014  Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------!
+! Copyright 1997-2017  Leibniz Universitaet Hannover
+!------------------------------------------------------------------------------!
 !
 ! Current revisions:
@@ -32,5 +33,5 @@
 ! -------------
 ! Ueberpruefung der Konsistenz von Prozessortopologie und gewaehlten Feldgrenzen
-!-------------------------------------------------------------------------------!
+!------------------------------------------------------------------------------!
 
     IMPLICIT NONE
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/Makefile
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/Makefile	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/Makefile	(revision 2696)
@@ -0,0 +1,48 @@
+########################################################################################
+#
+#  KPP - The Kinetic PreProcessor
+#        Builds simulation code for chemical kinetic systems
+#
+#  Copyright (C) 1995-1996 Valeriu Damian and Adrian Sandu
+#  Copyright (C) 1997-2004 Adrian Sandu
+#
+#  KPP is free software; you can redistribute it and/or modify it under the
+#  terms of the GNU General Public License as published by the Free Software
+#  Foundation (http://www.gnu.org/copyleft/gpl.html); either version 2 of the
+#  License, or (at your option) any later version.
+#
+#  KPP is distributed in the hope that it will be useful, but WITHOUT ANY
+#  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+#  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
+#  details.
+#
+#  You should have received a copy of the GNU General Public License along
+##  with this program; if not, consult http://www.gnu.org/copyleft/gpl.html or
+#  write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+#  Boston, MA  02111-1307,  USA.
+#
+#  Adrian Sandu
+#  Computer Science Department
+#  Virginia Polytechnic Institute and State University
+#  Blacksburg, VA 24060
+#  E-mail: sandu@cs.vt.edu
+#
+#######################################################################################
+
+include Makefile.defs
+
+all: setup kpp
+
+setup:
+	@./cflags.guess $(CC)
+
+kpp:
+	@cd src;make;cd ..
+
+clean:
+	@cd src;make clean;cd ..
+	@rm -f *~ */*~
+
+distclean: clean
+	@cd src;make maintainer-clean;cd ..
+	@rm -f bin/kpp
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/Makefile.defs
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/Makefile.defs	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/Makefile.defs	(revision 2696)
@@ -0,0 +1,70 @@
+# -*- sh -*-
+##############################################################################
+#
+#  KPP - The Kinetic PreProcessor
+#        Builds simulation code for chemical kinetic systems
+#
+#  Copyright (C) 1995-1997 Valeriu Damian and Adrian Sandu
+#  Copyright (C) 1997-2005 Adrian Sandu
+#
+#  KPP is free software; you can redistribute it and/or modify it under the
+#  terms of the GNU General Public License as published by the Free Software
+#  Foundation (http://www.gnu.org/copyleft/gpl.html); either version 2 of the
+#  License, or (at your option) any later version.
+#
+#  KPP is distributed in the hope that it will be useful, but WITHOUT ANY
+#  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+#  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
+#  details.
+#
+#  You should have received a copy of the GNU General Public License along
+##  with this program; if not, consult http://www.gnu.org/copyleft/gpl.html or
+#  write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+#  Boston, MA  02111-1307,  USA.
+#
+#  Adrian Sandu
+#  Computer Science Department
+#  Virginia Polytechnic Institute and State University
+#  Blacksburg, VA 24060
+#  E-mail: sandu@cs.vt.edu
+#
+##############################################################################
+
+# In order to compile KPP you have to provide the following information:
+
+# 1. The name of the compiler you want to use. Normaly this 
+#    is either GNU C compiler (gcc) or the native compiler (cc)
+#    You can use the complete pathname if the compiler is not in $PATH 
+#    Note that for SUN machines is better to use gcc.
+#    For GNU C compiler use:
+#      CC=gcc
+#    For the native compiler use:
+#      CC=cc
+
+CC=cc 
+
+# 2. The name of your lexical analizer. KPP requires FLEX to be used.
+#    FLEX is a public domain lexical analizer and you can download it from
+#    http://www.gnu.org/software/flex/ or any other mirror site. If flex
+#    directory is not included in your path use the complete pathname.
+
+FLEX=flex
+
+# 3. The complete pathname of the FLEX library (libfl.a).
+#    On many systems this is either: 
+#    /usr/lib, /usr/lib64, /usr/local/util/lib/flex
+
+FLEX_LIB_DIR=/usr/lib64
+
+# 4. Platform independent C compiler flags. By default "-O" is used which 
+#    turns on optimization. If you are experiencing problems you may try 
+#    "-g" to include debuging informations.
+
+CC_FLAGS= -g -Wall
+
+# 5. Path to include additional directories
+#    Typically: /usr/include on Linux
+#               /usr/include/sys on Mac OS X
+INCLUDE_DIR = /usr/include
+
+##############################################################################
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/cflags
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/cflags	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/cflags	(revision 2696)
@@ -0,0 +1,1 @@
+ 
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/cflags.guess
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/cflags.guess	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/cflags.guess	(revision 2696)
@@ -0,0 +1,39 @@
+#!/bin/sh
+UNAME_MACHINE=`(uname -m) 2>/dev/null` || UNAME_MACHINE=unknown
+UNAME_RELEASE=`(uname -r) 2>/dev/null` || UNAME_RELEASE=unknown
+UNAME_SYSTEM=`(uname -s) 2>/dev/null` || UNAME_SYSTEM=unknown
+UNAME_VERSION=`(uname -v) 2>/dev/null` || UNAME_VERSION=unknown
+
+CC=cc
+if [ x$1 != x ]; then CC=$1; fi
+
+exec 5>./cflags
+
+# Note: order is significant - the case branches are not exclusive.
+
+case "${UNAME_MACHINE}:${UNAME_SYSTEM}:${UNAME_RELEASE}:${UNAME_VERSION}:${CC}" in
+
+    *:HP-UX:*:*:cc*) # For HP-UX workstations
+        echo " -Aa -D_HPUX_SOURCE " 1>&5; exit 0 ;;
+
+    *:AIX:*:*:cc*) # For machines running AIX
+        echo " -Aa " 1>&5; exit 0 ;;
+
+    *:IRIX:*:*:cc*) # For machines running IRIX
+        echo " " 1>&5; exit 0 ;;
+
+    *:IRIX64:*:*:cc*) # For machines running IRIX64 
+        echo " " 1>&5; exit 0 ;;
+
+    *:Linux:*:*:cc*) # For Linux machines
+        echo " " 1>&5; exit 0 ;;
+
+    *:SunOS:*:*:cc*) # For SUN machines
+        echo " Please use gcc compiler on SUN machines."; exit 1 ;;
+
+    *:*:*:*:gcc*) # this is the default case, for gcc
+        echo " " 1>&5; exit 0 ;;
+
+    *:*:*:*:*) # this is the default case
+        echo " " 1>&5; exit 0 ;;
+esac
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/exact.c
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/exact.c	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/exact.c	(revision 2696)
@@ -0,0 +1,56 @@
+void main()
+{
+KPP_REAL dval[NSPEC];
+FILE * fp;
+int i;
+ 
+/* ---- TIME VARIABLES ------------------ */
+
+  RTOLS = 1e-6;
+  TSTART = 3600*12;
+  TEND = TSTART + 3600*24*5;
+  DT = 3600.;
+  TEMP = 236.21;
+
+  Initialize();
+      
+  for( i = 0; i < NVAR; i++ ) {
+    RTOL[i] = RTOLS;
+    ATOL[i] = 1;
+  }
+  STEPMIN = 0.01;
+  STEPMAX = 900;
+      
+/* ********** TIME LOOP **************************** */
+
+  InitSaveData();
+
+  printf("\n%7s %7s   ", "done[%]", "Time[h]");
+  for( i = 0; i < NMONITOR; i++ )  
+    printf( "%8s  ", SPC_NAMES[MONITOR[i]] );
+  for( i = 0; i < NMASS; i++ )  
+    printf( "(%6s)  ", SMASS[i] );
+  
+  TIME = TSTART;
+  while (TIME <= TEND) {
+    GetMass( C, dval );
+    printf("\n%6.1f%% %7.2f   ", (TIME-TSTART)/(TEND-TSTART)*100, TIME/3600 );
+    for( i = 0; i < NMONITOR; i++ ) 
+      printf( "%8.2e  ", C[ MONITOR[i] ]/CFACTOR );
+    for( i = 0; i < NMASS; i++ ) 
+      printf( "%8.2e  ", dval[i]/CFACTOR );
+    
+    SaveData();
+
+    Update_SUN(); 
+    Update_RCONST();
+
+    INTEGRATE( DT );
+  }
+
+/* *********** END TIME LOOP *********************** */
+
+  printf("\n");
+  CloseSaveData();
+  GenerateMatlab("");
+}
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/exact.f
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/exact.f	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/exact.f	(revision 2696)
@@ -0,0 +1,67 @@
+      PROGRAM driver
+
+      INCLUDE 'KPP_ROOT_Parameters.h'
+      INCLUDE 'KPP_ROOT_Global.h'
+
+      KPP_REAL DVAL(NSPEC)
+      INTEGER i
+  
+C ---- TIME VARIABLES ------------------      
+
+      TSTART = 0
+      TEND = TSTART + 600
+      DT = 60.
+      TEMP = 298
+
+      STEPMIN = 0.01
+      STEPMAX = 900
+
+      RTOLS = 1e-8
+      do i=1,NVAR
+        RTOL(i) = RTOLS
+        ATOL(i) = 1e-3
+      end do
+     
+      CALL Initialize()
+
+C ********** TIME LOOP *************************
+
+      CALL InitSaveData()
+
+      write(6,990) (SPC_NAMES[MONITOR(i)], i=1,NMONITOR), 
+     *             (SMASS(i), i=1,NMASS )
+990   FORMAT('done[%] Time[h] ',20(4X,A6))
+
+      TIME = TSTART
+      do while (TIME .lt. TEND)
+
+        CALL GetMass( C, DVAL )
+        write(6,991) (TIME-TSTART)/(TEND-TSTART)*100, TIME/3600.,
+     *               (C(MONITOR(i))/CFACTOR, i=1,NMONITOR),
+     *               (DVAL(i)/CFACTOR, i=1,NMASS)
+991   FORMAT(F6.1,'% ',F7.2,3X,20(E10.4,2X))
+
+        CALL SaveData()
+
+        CALL Update_SUN() 
+        CALL Update_RCONST()
+
+        CALL INTEGRATE( TIME, TIME+DT )
+
+      end do
+
+      CALL GetMass( C, DVAL )
+      write(6,991) (TIME-TSTART)/(TEND-TSTART)*100, TIME/3600.,
+     *               (C(MONITOR(i))/CFACTOR, i=1,NMONITOR),
+     *               (DVAL(i)/CFACTOR, i=1,NMASS)
+
+      CALL SaveData()
+
+C *********** END TIME LOOP ********
+
+      CALL CloseSaveData()
+      CALL GenerateMatlab(' ')
+
+      STOP
+      END
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general.c
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general.c	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general.c	(revision 2696)
@@ -0,0 +1,63 @@
+int  InitSaveData();
+void Initialize();
+int  SaveData();
+int  CloseSaveData();
+int  GenerateMatlab( char * prefix );
+void GetMass( double CL[], double Mass[] );
+void INTEGRATE( double TIN, double TOUT );
+
+int main()
+{
+KPP_REAL dval[NSPEC];
+int i;
+ 
+/* ---- TIME VARIABLES ------------------ */
+
+  RTOLS = 1e-3;
+  TSTART = 3600*12;
+  TEND = TSTART + 3600*24*5;
+  DT = 3600.;
+  TEMP = 236.21;
+
+  Initialize();
+      
+  for( i = 0; i < NVAR; i++ ) {
+    RTOL[i] = RTOLS;
+    ATOL[i] = 1.0;
+  }
+  STEPMIN = 0.01;
+  STEPMAX = 900;
+      
+/* ********** TIME LOOP **************************** */
+
+  InitSaveData();
+
+  printf("\n%7s %7s   ", "done[%]", "Time[h]");
+  for( i = 0; i < NMONITOR; i++ )  
+    printf( "%8s  ", SPC_NAMES[MONITOR[i]] );
+  for( i = 0; i < NMASS; i++ )  
+    printf( "(%6s)  ", SMASS[i] );
+  
+  TIME = TSTART;
+  while (TIME <= TEND) {
+    GetMass( C, dval );
+    printf("\n%6.1f%% %7.2f   ", (TIME-TSTART)/(TEND-TSTART)*100, TIME/3600 );
+    for( i = 0; i < NMONITOR; i++ ) 
+      printf( "%9.3e  ", C[ MONITOR[i] ]/CFACTOR );
+    for( i = 0; i < NMASS; i++ ) 
+      printf( "%9.3e  ", dval[i]/CFACTOR );
+    
+    SaveData();
+
+    INTEGRATE( TIME , TIME+DT );
+    TIME += DT;
+  }
+
+/* *********** END TIME LOOP *********************** */
+
+  printf("\n");
+  CloseSaveData();
+
+    return 0; /*didnt return anything initially */
+
+}
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general.f
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general.f	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general.f	(revision 2696)
@@ -0,0 +1,72 @@
+      PROGRAM driver
+
+      INCLUDE 'KPP_ROOT_Parameters.h'
+      INCLUDE 'KPP_ROOT_Global.h'
+
+      KPP_REAL DVAL(NSPEC)
+      INTEGER i
+  
+C ---- TIME VARIABLES ------------------      
+
+      TSTART = 0
+      TEND = TSTART + 600
+      DT = 60.
+      TEMP = 298
+
+      STEPMIN = 0.01
+      STEPMAX = 900
+
+      RTOLS = 1e-3
+      DO i=1,NVAR
+        RTOL(i) = RTOLS
+        ATOL(i) = 1
+      END DO
+     
+      CALL Initialize()
+
+C ********** TIME LOOP *************************
+
+      CALL InitSaveData()
+
+      WRITE(6,990) (SPC_NAMES(MONITOR(i)), i=1,NMONITOR), 
+     *             (SMASS(i), i=1,NMASS )
+990   FORMAT('Done[%] Time[h] ',20(4X,A6))
+
+      TIME = TSTART
+      DO WHILE (TIME .lt. TEND)
+
+        CALL GetMass( C, DVAL )
+        WRITE(6,991) (TIME-TSTART)/(TEND-TSTART)*100, TIME/3600.,
+     *               (C(MONITOR(i))/CFACTOR, i=1,NMONITOR),
+     *               (DVAL(i)/CFACTOR, i=1,NMASS)
+991   FORMAT(F6.1,'% ',F7.2,3X,20(E10.4,2X))
+
+        CALL SaveData()
+
+        CALL Update_SUN() 
+        CALL Update_RCONST()
+
+        CALL INTEGRATE( TIME, TIME+DT )
+
+      END DO
+
+      CALL GetMass( C, DVAL )
+      WRITE(6,991) (TIME-TSTART)/(TEND-TSTART)*100, TIME/3600.,
+     *               (C(MONITOR(i))/CFACTOR, i=1,NMONITOR),
+     *               (DVAL(i)/CFACTOR, i=1,NMASS)
+
+      CALL SaveData()
+
+C *********** END TIME LOOP ********
+
+      CALL CloseSaveData()
+
+      open(75, file='reference.data')
+      do i=1,KPP_NVAR
+        write(75,75) VAR(i)
+      end do
+75    FORMAT(100(E24.14,1X))      
+
+      STOP
+      END
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general.f90
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general.f90	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general.f90	(revision 2696)
@@ -0,0 +1,54 @@
+PROGRAM KPP_ROOT_Driver
+
+  USE KPP_ROOT_Model
+  USE KPP_ROOT_Initialize, ONLY: Initialize
+
+      KPP_REAL :: T, DVAL(NSPEC)
+      KPP_REAL :: RSTATE(20)
+      INTEGER :: i
+  
+!~~~> Initialization 
+
+      STEPMIN = 0.0d0
+      STEPMAX = 0.0d0
+
+      DO i=1,NVAR
+        RTOL(i) = 1.0d-4
+        ATOL(i) = 1.0d-3
+      END DO
+     
+      CALL Initialize()
+      CALL InitSaveData()
+
+!~~~> Time loop
+      T = TSTART
+kron: DO WHILE (T < TEND)
+
+        TIME = T
+        CALL GetMass( C, DVAL )
+        WRITE(6,991) (T-TSTART)/(TEND-TSTART)*100, T,       &
+                   ( TRIM(SPC_NAMES(MONITOR(i))),           &
+                     C(MONITOR(i))/CFACTOR, i=1,NMONITOR )
+        CALL SaveData()
+        CALL Update_SUN() 
+        CALL Update_RCONST()
+
+        CALL INTEGRATE( TIN = T, TOUT = T+DT, RSTATUS_U = RSTATE, &
+        ICNTRL_U = (/ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 /) )
+        T = RSTATE(1)
+
+      END DO kron
+!~~~> End Time loop
+
+      CALL GetMass( C, DVAL )
+      WRITE(6,991) (T-TSTART)/(TEND-TSTART)*100, T,     &
+               ( TRIM(SPC_NAMES(MONITOR(i))),           &
+                 C(MONITOR(i))/CFACTOR, i=1,NMONITOR ) 
+      TIME = T
+      CALL SaveData()
+      CALL CloseSaveData()
+
+991   FORMAT(F6.1,'%. T=',E9.3,2X,200(A,'=',E11.4,'; '))
+
+END PROGRAM KPP_ROOT_Driver
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general.m
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general.m	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general.m	(revision 2696)
@@ -0,0 +1,83 @@
+
+  TSTART = 0;
+  TEND = TSTART + 600;
+  DT = 60.;
+  TEMP = 298;
+
+  RTOLS = 1.0e-6;
+  ATOLS = 1.0e-3;
+     
+  KPP_ROOT_Initialize;
+  
+  Options = odeset('AbsTol',ATOLS,'RelTol',RTOLS,'Jacobian',@KPP_ROOT_Jac_Chem);
+
+% ********** TIME LOOP *************************
+
+  C(1:KPP_NVAR) = VAR(1:KPP_NVAR); 
+  C((KPP_NVAR+1):KPP_NSPEC) = FIX(1:KPP_NFIX);
+  DVAL = KPP_ROOT_GetMass( C );
+  if ( ~isempty(SMASS) )
+     fprintf('Initial Mass = %10.4e\n', DVAL(1:NMASS)/CFACTOR);
+  end   
+  
+%  KPP_ROOT_InitializeSaveData;
+
+%  disp(['Done[%] Time[h] ',SPC_NAMES(MONITOR(1:NMONITOR))])
+
+  TIME = TSTART;
+  
+  Tspan = linspace( TSTART, TEND, 100 );
+
+  [T, Y] = ode15s(@KPP_ROOT_Fun_Chem, Tspan, VAR, Options);
+
+  VAR(1:KPP_NVAR) = Y(length(T),1:KPP_NVAR)';
+  Y = [Y, ones(length(T),1)*FIX(:)'];
+  
+  C(1:KPP_NVAR) = VAR(1:KPP_NVAR); 
+  C((NVAR+1):NSPEC) = FIX(1:NFIX);
+  DVAL = KPP_ROOT_GetMass( C );
+	
+  fprintf('done %6.1f,  %7.2h hours', (TIME-TSTART)/(TEND-TSTART), TIME/3600.);
+  disp( Y(:,MONITOR(1:NMONITOR))/CFACTOR );
+  if ( ~isempty(SMASS) )
+    fprintf('Final Mass = %10.4e\n', DVAL(1:NMASS)/CFACTOR);
+  end
+  
+  for i = 1:NMONITOR
+    figure; plot( (T)/3600, Y(:,MONITOR(i))/CFACTOR );
+    title( SPC_NAMES( MONITOR(i),:) ,'FontSize',12); 
+    set(gca,'XLim',[TSTART,TEND]/3600,'FontSize',12);
+    xlabel('Time [ h ]','FontSize',12);
+    ylabel('Concentration','FontSize',12);
+  end  
+
+%   KPP_ROOT_FUNC_SaveData;
+%   KPP_ROOT_FUNC_CloseSaveData;
+
+return
+
+
+%  function P = KPP_ROOT_Fun_Chem(T, Y) 
+%       
+%    global TIME FIX RCONST  
+%   
+%    Told = TIME;
+%    TIME = T;
+%    KPP_ROOT_Update_SUN;
+%    KPP_ROOT_Update_RCONST;
+%    P = KPP_ROOT_Fun( Y, FIX, RCONST );
+%    TIME = Told;
+%  return
+%  
+%   
+%  function J =  KPP_ROOT_Jac_Chem(T, Y)   
+%    
+%    global TIME FIX RCONST ; 
+%    
+%    Told = TIME;
+%    TIME = T;
+%    KPP_ROOT_Update_SUN;
+%    KPP_ROOT_Update_RCONST;
+%    J = KPP_ROOT_Jac_SP( Y, FIX, RCONST );
+%    TIME = Told
+%  return              
